---

- name: Ensure Docker Node exists on Hetzner
  gather_facts: false
  connection: local
  hosts: localhost
  tasks:
    - name: Ensure Docker Node is created
      hcloud_server:
        name: "{{ env }}-docker"
        server_type: cx11
        image: ubuntu-20.04
        user_data: "#include https://get.docker.com"
        location: fsn1
        ssh_keys:
          - "0boro"
        labels:
          docker: ""
          environment: "{{ env }}"
        state: started
        api_token: "{{ lookup('env','HCLOUD_TOKEN') }}"

- name: Ensure Docker server is deployed
  hosts: label_docker_:&label_environment_{{ env }}
  pre_tasks:
    - name: Wait for cloud init to finish
      become: true
      stat:
        path: /var/lib/cloud/instance/boot-finished
      register: cloud_init
      until: cloud_init.stat.exists
      retries: 50
      delay: 5
  tasks:
    - name: Ensure common role is imported
      import_role:
        name: common

    - name: Update and upgrade apt packages
      become: true
      apt:
        upgrade: true
        update_cache: true

    - name: Check if reboot is required
      become: true
      stat:
        path: /var/run/reboot-required
      register: _reboot_required

    - name: Reboot if needed
      become: true
      reboot:
      when: _reboot_required.stat.exists

    - name: Apt autoremove not needed packages
      become: true
      apt:
        autoremove: true
